// src/context/utils.ts
import { createClient } from "@wix/sdk";
import { SiteSessionAuth } from "@wix/sdk/auth/site-session";
var isBackofficeExtension = location.pathname.startsWith(
  "/_wix/extensions/backoffice"
);
function getCookieAsJson(name) {
  const cookies = document.cookie.split("; ");
  const cookie = cookies.find((row) => row.startsWith(`${name}=`));
  if (!cookie) {
    return null;
  }
  try {
    const jsonString = decodeURIComponent(cookie.split("=")[1] ?? "");
    return JSON.parse(jsonString);
  } catch (error) {
    console.error("Error parsing cookie JSON:", error);
    return null;
  }
}
function getSessionClient(options) {
  return createClient({
    auth: SiteSessionAuth({
      tokens: getCookieAsJson("wixSession")?.tokens,
      ...options
    })
  });
}

export {
  isBackofficeExtension,
  getSessionClient
};
