import type { TypeNames, VariantOf } from 'variant';
import { fields, variant } from 'variant';
import type {
  BaseDevCenterComponent,
  DevCenterBackofficeExtensionMenuItem,
  DevCenterBackofficeExtensionWidget,
  DevCenterBackofficeModal,
  DevCenterBackofficePage,
  DevCenterEcomAdditionalFees,
  DevCenterEcomDiscountsTrigger,
  DevCenterEcomGiftCardsProvider,
  DevCenterEcomPaymentSettings,
  DevCenterEcomShippingRates,
  DevCenterEcomValidations,
  DevCenterWebhook,
} from './schemas.js';

export const Component = variant({
  BackofficeExtensionMenuPlugin: fields<{
    directory: string;
    manifest: DevCenterBackofficeExtensionMenuItem;
  }>(),
  BackofficeExtensionWidget: fields<{
    directory: string;
    manifest: DevCenterBackofficeExtensionWidget;
  }>(),
  BackofficeModal: fields<{
    directory: string;
    manifest: DevCenterBackofficeModal;
  }>(),
  BackofficePage: fields<{
    directory: string;
    manifest: DevCenterBackofficePage;
  }>(),
  EcomAdditionalFees: fields<{
    directory: string;
    manifest: DevCenterEcomAdditionalFees;
  }>(),
  EcomDiscountsTrigger: fields<{
    directory: string;
    manifest: DevCenterEcomDiscountsTrigger;
  }>(),
  EcomGiftCardsProvider: fields<{
    directory: string;
    manifest: DevCenterEcomGiftCardsProvider;
  }>(),
  EcomPaymentSettings: fields<{
    directory: string;
    manifest: DevCenterEcomPaymentSettings;
  }>(),
  EcomShippingRates: fields<{
    directory: string;
    manifest: DevCenterEcomShippingRates;
  }>(),
  EcomValidations: fields<{
    directory: string;
    manifest: DevCenterEcomValidations;
  }>(),
  Webhook: fields<{
    directory: string;
    manifest: DevCenterWebhook;
  }>(),
});

export type Component<T extends TypeNames<typeof Component> = undefined> =
  VariantOf<typeof Component, T>;

export const UnknownComponent = variant({
  Unknown: fields<{
    directory: string;
    manifest: BaseDevCenterComponent;
  }>(),
});

export type UnknownComponent<
  T extends TypeNames<typeof UnknownComponent> = undefined,
> = VariantOf<typeof UnknownComponent, T>;
