import { dashboard } from '@wix/dashboard';
import { createClient } from '@wix/sdk';
import { getSessionClient, isBackofficeExtension } from './utils.js';

function getBackofficeClient() {
  return createClient({
    auth: dashboard.auth(),
    host: dashboard.host(),
    modules: {
      dashboard,
    },
  });
}

export function setup(options: { clientId: string }) {
  const client = isBackofficeExtension
    ? getBackofficeClient()
    : getSessionClient(options);

  client.enableContext('global');
}
