import type { PluginOption } from 'vite';

// - https://github.com/facebookarchive/draft-js/issues/2127
// - https://github.com/facebook/fbjs/issues/290
const define = { global: 'window' } as const;

export function patchGlobal(): PluginOption {
  return [
    {
      apply: 'serve',
      config: () => ({ optimizeDeps: { esbuildOptions: { define } } }),
      name: 'fix-draft-js',
    },
    {
      apply: 'build',
      config: () => ({ esbuild: { define } }),
      name: 'fix-draft-js',
    },
  ];
}
