import type { Component } from '../components.js';

export function isValidBackofficeComponent(
  component: Component
): component is
  | Component<'BackofficeExtensionWidget'>
  | Component<'BackofficeModal'>
  | Component<'BackofficePage'> {
  return (
    (component.type === 'BackofficePage' &&
      !component.manifest.compData.backOfficePage.iframeUrl) ||
    (component.type === 'BackofficeExtensionWidget' &&
      !component.manifest.compData.backOfficeExtensionWidget.iframeUrl) ||
    (component.type === 'BackofficeModal' &&
      !component.manifest.compData.backOfficeModal.iframeUrl)
  );
}
