import type { Component } from '../components.js';

export function isValidServicePluginComponent(
  component: Component
): component is
  | Component<'EcomAdditionalFees'>
  | Component<'EcomDiscountsTrigger'>
  | Component<'EcomGiftCardsProvider'>
  | Component<'EcomPaymentSettings'>
  | Component<'EcomShippingRates'>
  | Component<'EcomValidations'> {
  return (
    (component.type === 'EcomShippingRates' &&
      !component.manifest.compData.ecomShippingRates.deploymentUri) ||
    (component.type === 'EcomAdditionalFees' &&
      !component.manifest.compData.ecomAdditionalFees.deploymentUri) ||
    (component.type === 'EcomDiscountsTrigger' &&
      !component.manifest.compData.ecomDiscountsTrigger.deploymentUri) ||
    (component.type === 'EcomValidations' &&
      !component.manifest.compData.ecomValidations.deploymentUri) ||
    (component.type === 'EcomPaymentSettings' &&
      !component.manifest.compData.ecomPaymentSettings.deploymentUri) ||
    (component.type === 'EcomGiftCardsProvider' &&
      !component.manifest.compData.giftCardsProvider.deploymentUri)
  );
}
