import type { Tokens } from '@wix/sdk';
import type { APIContext } from 'astro';
import { WIX_CLIENT_ID } from 'astro:env/client';

function sessionCookieJson(tokens: Tokens) {
  return {
    clientId: WIX_CLIENT_ID,
    tokens,
  };
}

export function saveSessionTokensToCookie(context: APIContext, tokens: Tokens) {
  context.cookies.set('wixSession', sessionCookieJson(tokens), {
    path: '/',
    secure: true,
  });
}
